#include "Coord.h"

Coord::Coord(const ustring& c)
{
    if(c.size()!=2 ||
       !Glib::Unicode::isalpha(c[0]) ||
       !Glib::Unicode::isalpha(c[1]) ||
       !Glib::Unicode::islower(c[0]) ||
       !Glib::Unicode::islower(c[1]))
        throw CoordError(ustring::compose("Coord::Coord(const ustring&):\
                          needs exactly two alpha lower case characters. Encountered: \"%1\"",c));
    else {
        std::string raw=c.raw();
        m_i=(int)(raw[0])-(int)'a';
        m_j=(int)(raw[1])-(int)'a';
    }
}

Coord::operator ustring () const
{
    ustring out="";
    out.push_back((char)(m_i+(int)'a'));
    out.push_back((char)(m_j+(int)'a'));
    return out;
}

Coord& Coord::operator=(const Coord& c)
{
    if(&c==this) return *this;
    else {
        m_i=c.i();
        m_j=c.j();
        return *this;
    }
}

bool operator==(const Coord& left, const Coord& right)
{
    return left.m_i==right.m_i && left.m_j==right.m_j;
}

std::ostream& operator<<(std::ostream& out, const Coord& right)
{
	out<<"("<<right.i()<<","<<right.j()<<")";
	return out;
}

ostream& operator<<(ostream& os, const CoordError& err)
{
    os<<"CoordError: "<<err.what();
    return os;
}
