#ifndef _LOGGER_H
#define _LOGGER_H

#include <iostream>
#include <fstream>
#include <string>
#include <glibmm.h>
#include <ctime>

class Logger{
	private:
		Logger(){}
		std::ofstream m_stream;
		~Logger(){
			if(m_stream.is_open()) m_stream.close();
		}
	public:
		static std::ostream& log() {
			static Logger m_log;
			if(!m_log.m_stream.is_open()){
				m_log.m_stream.open((Glib::get_home_dir().append("/ggoban.log")).c_str());
				std::time_t rawtime;
				struct std::tm * timeinfo;
				std::time(&rawtime);
				timeinfo=std::localtime(&rawtime);
				m_log.m_stream<<"ggoban log file"<<std::endl<<"date: "<<std::asctime(timeinfo)<<std::endl;
			}
			return (std::ostream&)m_log.m_stream;
		}
};

#endif
