#ifndef _OPPONENT_H
#define _OPPONENT_H

#include "SgfNode.h"

class Opponent {
    public:
        Opponent() :m_is_playing(false), m_game_over(false) {}
        virtual ~Opponent() {}
        virtual void ToPlay(SgfNode* lastmove)=0;
        virtual void GetScore()=0;
        sigc::signal<void> signal_resign() {return m_signal_resign;}
        sigc::signal<void,SgfNode*> signal_played() {return m_signal_played;}
        sigc::signal<void,vector<Coord>,vector<Coord>,vector<Coord> > signal_final_state() {return m_signal_final_state;}
        bool IsPlaying() {return m_is_playing;}
        bool GameOver() {return m_game_over;}
        virtual void Resignation() {}
    protected:
        bool m_is_playing;
        bool m_game_over;
        sigc::signal<void> m_signal_resign;
        sigc::signal<void,SgfNode*> m_signal_played;
        sigc::signal<void,vector<Coord>,vector<Coord>,vector<Coord> > m_signal_final_state;
};

#endif
